---
title: Specification tables
slug: MDN/Structures/Specification_tables
tags:
  - Guide
  - MDN Meta
  - Structures
---
<div>{{MDNSidebar}}</div>

<p>Every reference page on MDN should provide information about the specification or specifications in which that API or technology was defined. This article demonstrates what these tables look like and explains how to construct them.</p>

<p>These tables are similar in some respects to the <a href="/en-US/docs/MDN/Contribute/Structures/Compatibility_tables">compatibility tables</a> (which should also be present on any page that has a specification table).</p>

<h2 id="Format">Format</h2>

<p>A specification table has traditionally consisted of three columns:</p>

<dl>
 <dt>Specification</dt>
 <dd>The name of and link to the specification in which the technology is defined.</dd>
 <dt>Status</dt>
 <dd>The specification's status (for example, whether it's an editor's draft or a candidate recommendation).</dd>
 <dt>Comment</dt>
 <dd>Any additional information that may be relevant. This can be particularly helpful when an API is defined across multiple specifications, so that you can explain briefly what parts of the API come from each one.</dd>
</dl>

<p>Most of the tables you'll find on MDN consist of the above described columns, however, there are plans afoot to update the structure, so you might find some different structures here and there, and the eventual aim is to store spec definition links in our <a href="https://github.com/mdn/browser-compat-data">browser compat data repo</a>, and auto-generate them from there. You can find a public discussion document at <a href="https://docs.google.com/document/d/1eL8YtslVZAnIAGb7rcZGbvXndkcR7lb9rhDpvGpGaWs/edit#">Improving MDN Specification tables</a>.</p>

<h2 id="Which_specs_should_be_included">Which specs should be included?</h2>

<p>Each row in the table describes one specification on which the API or technology is based.</p>

<p>Which specs to include in each table depends on what features are being discussed on the reference page in question.</p>

<ul>
 <li>If it is just a single feature of a spec, you usually just need to include a single line that details the latest spec the feature is defined in. See the <a href="/en-US/docs/Web/API/AudioContext/close#Specifications"><code>AudioContext.close()</code> Specifications</a>, for example.</li>
 <li>If it is a landing page for an API where different parts of the API (e.g. extensions) are defined in different specs, you may need multiple lines referencing different specs. See the <a href="/en-US/docs/Web/API/Gamepad_API#Specifications">Gamepad API Specifications</a> for a simple clear example.</li>
</ul>

<h3 id="Different_types_of_specs">Different types of specs</h3>

<p>For technologies defined in "living specs" (for example <a href="https://html.spec.whatwg.org/multipage/">HTML</a>, or <a href="https://dom.spec.whatwg.org/">DOM</a>), you'll probably only need to link to a single spec as that is the single canonical place where the technology will be defined.</p>

<p>Other specs (normally WebAPI specs) will tend to have a single URL that always points to the latest editor's draft, whichever spec that is (not always the same spec). In such cases, it is usually better to link to the latest editor's draft so that as the latest spec changes, the link will stay correct — the latest editor's draft is where all the latest features are defined and what browser vendors usually work from. This is therefore the most interesting place to link to, which is most likely to be up-to-date. Examples of this include the <a href="https://w3c.github.io/IndexedDB/">IndexedDB draft</a>, <a href="https://webaudio.github.io/web-audio-api/">Web Audio API draft</a>, etc. You can find the latest draft link at the top of each specification.</p>

<p>Other specs will have the core functionality defined in one spec, but then other specs will extend that functionality, for example The Credential Management spec is extened by the Web Authentication spec (<a href="/en-US/docs/Web/API/Credential_Management_API#Specifications">see the spec table</a>).</p>

<p>With CSS specs, it is not that simple — CSS specs are generally broken up into different Levels, which introduce new functionality — for example <a href="https://drafts.csswg.org/mediaqueries-4/">Media Queries Level 4</a> and <a href="https://drafts.csswg.org/mediaqueries-5/">Media Queries Level 5</a>. You'll often have to link to multiple specs to show where all the functionality of a feature is defined.</p>

<p>When adding specs to MDN (see how below), keep the above ideas in mind. Represent living standards as just the name of the technology (e.g. "HTML"). Represent latest spec drafts as <em>WebAPI name</em> draft (e.g. "IndexedDB draft"). Where multiple specs are required, use the exact name of the spec.</p>

<h3 id="What_not_to_include">What not to include</h3>

<p>There are a number of spec tables on MDN where we've included all the specs that define a feature, back to ancient times. For example, the <a href="/en-US/docs/Web/CSS/color#Specifications">CSS color property spec table</a>. This goes all the way back to CSS level 1, but you probably don't need the bottom three rows of the table. Everything is defined in Level 4, except for the part about colors being animatable.</p>

<p>You especially don't need to refer to specs that are marked as obsolete. They aren't helpful.</p>

<p>Also, <a href="https://www.w3.org/2019/04/WHATWG-W3C-MOU.html#transition">the W3C agreed to stop publishing snapshots of technology specs also covered by WHATWG living standards</a> — for technologies covered by both, you can just list the WHATWG spec.</p>

<h2 id="Macros">Macros</h2>

<p>To help construct these tables in a standard format, with appropriate styling, we use KumaScript macros. There are two of these you need to know how to use.</p>

<h3 id="SpecName"><code>\{{SpecName}}</code></h3>

<p>The {{TemplateLink("SpecName")}} macro is used to create the contents of the "Specification" column. It accepts three parameters:</p>

<ol>
 <li>The name of the specification.</li>
 <li>An optional anchor within the linked specification; this lets you link to a particular section in a specification that defines multiple objects or interfaces, for example. Note that even if this parameter optional, it is strongly recommended: when the readers click on the generated link, they expect to reach the precise place in the spec where the concept is defined.</li>
 <li>The property or entity name to use in the tooltip; this, too, is used when linking to specific interfaces within a specification. Although this parameter is also optional, it is strongly recommended to add it and it should be set to the name of the concept.</li>
</ol>

<p>The names you may specify for specifications can be seen by looking at the <code>specList</code> object in the macro. If the specification you want to link to is not supported by the macro, propose a pull request that updates the <a href="https://github.com/mdn/kumascript/blob/master/macros/SpecData.json">SpecData</a> file.</p>

<h3 id="Spec2"><code>\{{Spec2}}</code></h3>

<p>The {{TemplateLink("spec2")}} macro creates and inserts a widget indicating the status of a specification into the "Status" column, given the name of a specification. It also gets its data from the <a href="https://github.com/mdn/kumascript/blob/master/macros/SpecData.json">SpecData</a> file. Again, if the specification you want to link to is not supported by the macro, propose a pull request.</p>
